#include <AR/ar.h>
#include "image_process.h"
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <vector>
#define MAX(a,b)            (((a) > (b)) ? (a) : (b))
const double PI = acos(-1.0);

//Է  ġȭ ̹  .
//Է 󿡼 0:  ü 
//Է 󿡼 255:  ü


/***************************************************************
// ߽
***************************************************************/
void get_center(ARUint8   *dataPtr,int xsize,int ysize,int *center_x,int *center_y,int data)
{
	int x,y;
	unsigned long x_sum=0;
	unsigned long y_sum=0;
	unsigned long center_count=1;

	for(y=0;y<ysize;y++){
		for(x=0;x<xsize;x++)		{
			if(dataPtr[y*xsize*BPP+BPP*x]==data){
				x_sum+=x;				
				y_sum+=y;
				center_count++;
			}
		}
	}
	if(center_count !=0){	
		(*center_x)=x_sum/center_count;
		(*center_y)=y_sum/center_count;
		(*center_y)=ysize-(*center_y);
	}
}


point first_point;// 


/***************************************************************
// Լ 
***************************************************************/
//ߺǴ   - x,y   
void sort_and_remove_duplicates(point in[],int *n);
//Ʈ compare Լ
int leftlower(const void *com1,const void *com2);
int smaller_angle(const void *com1,const void *com2);
//convex hull 
void convex_hull(point in[],int n,polygon *hull);

bool collinear(point a,point b, point c);


/***************************************************************
// point copy
***************************************************************/
void copy_point(point p1, point *p2)
{
	p2->x = p1.x;
	p2->y = p1.y;
}



/***************************************************************
// ﰢ  ϱ
//
// ﰢ ̸   ִ.
// ﰢ 1/2(*)
//
// ax ay 1
// bx by 1  =  axby - aybx + aycx - axcy + bxcy - cxby
// cx cy 1 
***************************************************************/
double signed_triangle_area(point a,point b,point c)
{
	return ( (a.x * b.y - a.y*b.x + a.y*c.x - a.x * c.y + b.x * c.y - c.x * b.y)/2.0);
}

/***************************************************************
//ٰ         ٰ ȿ  
// ٰ  ̴ٰ.
***************************************************************/
bool ccw(point a,point b, point c)
{		
	return ((signed_triangle_area(a,b,c)) > EPSILON);
}

/***************************************************************
//c  ab ϼ   0̰ ʿ   ȴ.
//ε Ҽ  ߻ ̱  0  EPSILON ߴ. 
//̰    ϴ .   εҼ 
// ذ  .
***************************************************************/
bool collinear(point a,point b, point c)
{	
	return (fabs(signed_triangle_area(a,b,c))<= EPSILON);
}

/***************************************************************
//2 Ÿ ϱ
//
//   (x1, y1) (x2, y2)  Ÿ Ÿ = sqrt([x1-x2]2+[y1-y2]2)̴
***************************************************************/
double distance(point p1, point p2)
{
	return (    sqrt( (double) ((p2.x-p1.x)*(p2.x-p1.x)+(p2.y-p1.y)*(p2.y-p1.y))) );
}

/***************************************************************
// sort_and_remove_duplicates
//
//ߺǴ   Ѵ.
//Էµ ǥ x  ͺ Ѵ. x ٸ y  
***************************************************************/
void sort_and_remove_duplicates(point in[],int *n)
{
	int i; //ī
	int oldn; //   
	int hole; // ɼ ִ  ǥϱ  ε	
	qsort(in,*n,sizeof(point),leftlower);

	//DEBUG Message
	/*
	printf("ǥ   \n");
	for(i=0;i<*n;i++)
	printf("%f %f\n",in[i].x,in[i].y);
	*/
	


	oldn = *n;
	hole = 1;

	//ߺǴ    . 
	for(i=1;i<(oldn-1);i++){
		if((in[hole-1].x==in[i].x) && (in[hole-1].y==in[i].y))
			(*n)--;
		else{
			copy_point(in[i],&in[hole]);
			hole = hole + 1;
		}
	}
	copy_point(in[oldn-1],&in[hole]);

	//DEBUG Message
	/*
	printf("\n\n");
	printf("ߺ  \n");
	for(i=0;i<*n;i++)
	printf("%f %f\n",in[i].x,in[i].y);
	*/
	

}

/***************************************************************
// Ʈ compare Լ

1. leftlower
2. smaller_angle
***************************************************************/
//x   Ѵ. x ٸ y   Ѵ.
// ǥ  ǥμ  .
//
//      |
//      |
//   y|
//      ------------>  x

//1. leftlower - ǥ 
int leftlower(const void *com1,const void *com2) // check first more left and check more lower.
{
	point *p1,*p2;
	p1=(point *)com1;
	p2=(point *)com2;

	if(p1->x < p2->x) return (-1);
	if(p1->x > p2->x) return (1); // if p2 locates more left side, return TRUE.

	if(p1->y < p2->y) return (-1); // if p2 locates more lower side, return TRUE.
	if(p1->y > p2->y) return (1);

	return (0);
}

//2. smaller_angle -  
int smaller_angle(const void *com1,const void *com2) 
{
	point *p1,*p2;
	p1=(point *)com1;
	p2=(point *)com2;	

	//  ִ° 
	//ָ ִ° ڿ ĵȴ.
	//  ִ   ָ ִ   ߰Ǳ⶧    ִ
	//ٸ  ᱹ ּ  ٰ ܵȴ.

	if(collinear(first_point,*p1,*p2)){
		if(distance(first_point,*p1) <= distance(first_point,*p2))
			return (-1);
		else 
			return (1);
	}
	if(ccw(first_point,*p1,*p2))
		return (-1);
	else
		return (1);
}

//Ʈ   - max  ã´
int inter_func(const void *com1,const void *com2) 
{
	inter_struct *p1,*p2;
	p1=(inter_struct *)com1;
	p2=(inter_struct *)com2;		
	return (p1->f_inter < p2->f_inter) ;

}



/***************************************************************
// convex_hull
***************************************************************/
void convex_hull(point in[],int n,polygon *hull,int range,point center)
{
	int i;//Է ī 
	int top;//ּ  ٰ  ũ
	

	if(n<=3){//  ּ  ٰ  ־ 
		for(i=0;i<n;i++)
			copy_point(in[i],&hull->p[i]);
		hull->n = n;
		return; 
	}	
	sort_and_remove_duplicates(in,&n);	
	copy_point(in[0],&first_point);	

	qsort(&in[1],n-1,sizeof(point),smaller_angle);
		
	/*
	printf("\n\n");
	printf("   \n");
	for(i=0;i<n;i++)
	printf("%f %f\n",in[i].x,in[i].y);
	*/
	
	
	copy_point(first_point,&hull->p[0]);	
	copy_point(in[1],&hull->p[1]);			
	
	//copy_point(first_point,&in[n]);
	top=1;
	i  =2;	


	while(i<n){		
		if(!ccw(hull->p[top-1],hull->p[top],in[i])){//3 ﰢ  ڷ .    ʿ ִٴ°
				top = top-1;							
		}
		else{						
			top = top+1;			
			//̺κ  ҽڵ忡 ذ ʾҴ   ̳
			//  ߻... ٽ ּó ϰڴ.
			//if(top>=0){
				copy_point(in[i],&hull->p[top]);
				i=i+1;
			//}
		}							
	}		
	//ó     ùƮ   .
	//׷Ƿ  ù Ʈ Ѵ.
	//̰     ù   2   ִٴ ̳,
	//ߺ ó ϸ  ̰,  ū    ִ.
	copy_point(first_point,&hull->p[++top]);
	hull->n = top+1;	


/*

	printf("first %f %f \n",first_point.x,first_point.y);
	
	printf("Ÿ  \n");
	for(i=0;i<hull->n;i++){
	printf("%f %f\n",hull->p[i].x,hull->p[i].y);
	}
*/	


	// Ÿ ϴ  濡  Ѵ. range	
  

	int oldn = hull->n;
	int hole = 1;	

	int r_count=0;
	float ds=0;

	point r_p;	//ֱ 
	copy_point(first_point,&r_p);//ֱ õ Ʈ
	
	for(i=1;i<oldn-1;i++){	
		
		//ֱ ǥ ǥ  Ÿ ̸		
		if( (ds=distance(r_p,hull->p[i])) < range){
			//  ǥ  Ÿ ָ Ѵ.
			if(  distance(center,r_p)     < distance(center,hull->p[i])){
				copy_point(hull->p[i],&r_p);//ֱ ǥ  ǥ ϰ
				copy_point(hull->p[i],&hull->p[r_count]);//ֱ ε Ѵ.
				hull->n --;

				//copy_point(hull->p[i],&hull->p[r_count]);				
				
			}
		}
		else{			
			r_count++; 
			copy_point(hull->p[i],&hull->p[r_count]);
			copy_point(hull->p[i],&r_p);
		}		
	}	
	copy_point( first_point ,&hull->p[++r_count]);	
	hull->n = r_count+1;  

}


/////////////////////////////////////////////////////////////////////////////
//ݺ 󺧸////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


int push(short *stackx, short *stacky,int arr_size,short vx,short vy,int *top)
{
	if(*top>=arr_size)return (-1);
	(*top)++;
	stackx[*top]=vx;
	stacky[*top]=vy;	
	return (1);
}

int pop(short *stackx,short *stacky, short *vx,short *vy,int *top)
{
	if(*top==0)return(-1);
	*vx=stackx[*top];
	*vy=stacky[*top];
	(*top)--;	
	return (1);
}

// Ѵٸ ݺ  ڵ 󺧸 ϴ.
// ϸ鼭  ū  󺧸ϴ ͵ ϴ.
int m_BlobColoring(ARUint8   *dataPtr,ARUint8   *outPtr,int width,int height)
{	
	int i,j,m,n,top,area,BlobArea[1000];
	short curColor=0,r,c;
	//  ޸ Ҵ
	short * stackx=new short[height*width];
	short * stacky=new short[height*width];
	int arr_size = height*width;
	//󺧸 ȼ ϱ  ޸ Ҵ
	short *coloring = new short[width*height];


	for(i=0;i<height*width;i++)
		coloring[i]=0;

	for(i=0;i<height;i++){
		for(j=0;j<width;j++){
			//̹ 湮 ̰ų ȼ 0 ƴ϶ ó
			if(coloring[i*width+j]!=0 || dataPtr[i*width*BPP+j*BPP]!=0)continue;
			//rc Ž Ʈ
			r=i;c=j;top=0;area=1;
			curColor++;


			while(1)//  鼭   ȭҵ 󺧸Ѵ.
			{
GRASSFIRE:					
				//m n ŽƮ r,cκ 8 Ž 
				for(m=r-1;m<=r+1;m++){
					for(n=c-1;n<=c+1;n++){

						// ȼ 踦  ó 
						if(m<0 || m>=height || n<0 || n>=width)continue;						

						//(m,n) ̹湮̰ ȭҰ 0 ŷϰ ÿ Ѵ.
						if((int)dataPtr[m*width*BPP+n*BPP]==0 && coloring[m*width+n]==0)
						{							
							coloring[m*width+n]=curColor;// 󺧷 ũ
							if(push(stackx,stacky,arr_size,(short)m,(short)n,&top)==-1)
								continue;							
							r=m;// 󺧸 ǥ ߽  ٽ 8ٹ ˻Ͽ 󺧸Ѵ.
							c=n;
							area++;
							goto GRASSFIRE;
						}
					}
				}
				// ̻  ȭ ߿ 󺧸  ٸ ÿ  ȼǥ  ´.
				//   ȭ ǥ ϵǾ ´. ׸ ٽ  ֺ
				//󺧸 Ѵ.
				if(pop(stackx,stacky,&r,&c,&top)==-1)break;

			}
			if(curColor<1000)BlobArea[curColor]=area;
			//printf("area = %d\n",area);
		}
	}

	float grayGap = 250.0f/(float)curColor;

	int max_blob=0;
	int max_blob_index=0;

	//  - ִ  
	for(i=0;i<=curColor;i++){
		//printf("%d:%d\n",i,BlobArea[i]);
		if(max_blob<BlobArea[i]){
			max_blob=BlobArea[i];
			max_blob_index=i;
		}
	}
	
	//󺧸 ͸ outPtr ȭ
	for(i=0;i<height;i++){
		for(j=0;j<width;j++){   //ִ ȭǥ
			if(coloring[i*width+j]==max_blob_index){
				int value=(int)(coloring[i*width+j]*grayGap);							
				outPtr[i*width*BPP+j*BPP]  =0;
				outPtr[i*width*BPP+j*BPP+1]=0;
				outPtr[i*width*BPP+j*BPP+2]=0;
				if(BPP == 4)
					outPtr[i*width*BPP+j*BPP+3]=0;					
			}
			else{
				outPtr[i*width*BPP+j*BPP]  =255;
				outPtr[i*width*BPP+j*BPP+1]=255;
				outPtr[i*width*BPP+j*BPP+2]=255;
				if(BPP == 4)
					outPtr[i*width*BPP+j*BPP+3]=255;				
			}
		}
	}

	free(stackx);
	free(stacky);
	free(coloring);
	return max_blob;

}


///////////////////////////////////////////////////////////////////////////////////////////////
//ȸ 
///////////////////////////////////////////////////////////////////////////////////////////////

void mask_processing(ARUint8   *dataPtr,ARUint8 outPtr[],int xsize,int ysize,int mask_size,int MaskBox[3][3])
{
	int mr,mc;
	int sum1=0,sum2=0,sum3=0;
	unsigned long index;
	unsigned long mask_index;
	int x,y;
	for(y=1;y<ysize-1;y++)
	{
		//index : ũ   Ų
		index=(y-1)*xsize*BPP;
		for(x=1;x<xsize-1;x=x+1){	
			for(mr=0;mr<mask_size;mr++){
				for(mc=0;mc<mask_size;mc++){
					mask_index=index+mr*(xsize*BPP) + mc*BPP;
					sum1+=(MaskBox[mr][mc]*dataPtr[mask_index  +  (x-1)*BPP+0]);//b													
					sum2+=(MaskBox[mr][mc]*dataPtr[mask_index  +  (x-1)*BPP+1]);//g
					sum3+=(MaskBox[mr][mc]*dataPtr[mask_index  +  (x-1)*BPP+2]);//r					
				}			
			}
			if(sum1<0)sum1 = -sum1;
			if(sum2<0)sum2 = -sum2;
			if(sum3<0)sum3 = -sum3;
			outPtr[index+BPP*x+0]=(int)(sum1);
			outPtr[index+BPP*x+1]=(int)(sum2);
			outPtr[index+BPP*x+2]=(int)(sum3);
			sum1=0;sum2=0;sum3=0;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////
// conver color model
///////////////////////////////////////////////////////////////////////////////////////////////
//(0<h && h<28) || (332<h && h<360)
void m_RGB2HSI   (ARUint8  *dataPtr,   ARUint8 outPtr[], int xsize, int ysize,int low_h_down,int low_h_up,int high_h_down,int high_h_up)
{
	int i;
	float r, g, b, h, s, iv;		
	int hmin=10000,hmax=0;
	float smin=10000,smax=0;		
	//	float avg;

	int m_histo[360];
	for(i=0;i<360;i++)
		m_histo[i]=0;

	for(i=0;i<xsize*ysize*BPP;i=i+BPP){
		r=dataPtr[i+2]/255.0f;
		g=dataPtr[i+1]/255.0f;
		b=dataPtr[i+0]/255.0f;	

		RGB_To_HSI(r,g,b,&h,&s,&iv);	
		h=h/360.f*255;
		s=(float)(s*255);
		iv=(float)(iv*255);

		if( ( (13<s && s<110) && ((low_h_down<h && h<low_h_up) || (high_h_down<h && h<high_h_up)) ) ){						
			outPtr[i+0]=0;outPtr[i+1]=0;outPtr[i+2]=0;
			if(BPP == 4)
				outPtr[i+3]=0;
		}	
		else{
			outPtr[i+0]=255;outPtr[i+1]=255;outPtr[i+2]=255;
			if(BPP == 4)
				outPtr[i+3]=255;
		}		
	}		
}



void RGB_To_HSI(float r, float g, float b, float *h, float *s, float *i)
{
	float minc;              /// minimum and maximum RGB values 
	float angle;             /// temp variable used to compute Hue 

	minc = MIN(r,g);
	minc = MIN(minc,b);

	/// compute intensity 
	*i=(r + g + b) / 3.0f;

	/// compute hue and saturation 
	if((r==g) && (g==b))  /// gray-scale 
	{
		*s = 0.0f;
		*h = 0.0f;
		return;
	}
	else{
		*s= 1.0f - (3.0f / (r + g + b)) * minc;
		angle = (r - 0.5f * g - 0.5f * b) / (float)sqrt((r - g) * (r - g)+(r - b) * (g - b));
		*h = (float)acos(angle);
		*h *= 57.29577951f;          /// convert to degrees 
	}

	if(b>g)	*h = 360.0f - *h;
}




void RGB_To_YCbCr   (ARUint8  *dataPtr,   ARUint8 outPtr[], int xsize, int ysize,int low_y_down,int low_y_up,int high_y_down,int high_y_up)
{
	unsigned long index;	
	int x,y;
	float r, g, b;
	double Y, Cb, Cr;			

	for(y=0;y<ysize;y++){
		index=y*xsize*BPP;
		for(x=0;x<xsize;x=x+1){			
			r=dataPtr[index+x*BPP+2];
			g=dataPtr[index+x*BPP+1];
			b=dataPtr[index+x*BPP+0];

			Y = 0.299 * r + 0.587 * g + 0.114 * b; 
			Cb = (b - Y) * 0.564 + 128; 
			Cr = (r - Y) * 0.713 + 128; 

			// شϴ κ 		
			if(  (Cb > low_y_down && Cb < low_y_up) && (Cr > high_y_down && Cr < high_y_up)){						
				
				outPtr[index+x*BPP+0]=0;
				outPtr[index+x*BPP+1]=0;
				outPtr[index+x*BPP+2]=0;
				if(BPP == 4)
					outPtr[index+x*BPP+3]=0;
			}
			else
			{					
				outPtr[index+x*BPP+0]=255;
				outPtr[index+x*BPP+1]=255;
				outPtr[index+x*BPP+2]=255;
				if(BPP == 4)
					outPtr[index+x*4+3]=0;//alpha		
			}		
		}
	}	
}


void rgb_segment   (ARUint8  *dataPtr,   ARUint8 outPtr[], int xsize, int ysize,int r_max,int g_max,int b_max,int all_max)
{
	int i;
	float r, g, b;			
	float r_g,rgb_max,rgb_min;
	for(i=0;i<xsize*ysize*BPP;i=i+BPP)
	{
		r=dataPtr[i+2];
		g=dataPtr[i+1];
		b=dataPtr[i+0];			

		//r - g
		r_g=r-g;
		if(r_g<0)
			r_g=-r_g;
		//rgb max
		if(r>g){
			if(r>b)rgb_max=r;
			else   rgb_max=b;
		}
		else{
			if(g>b)rgb_max=g;
			else   rgb_max=b;
		}			
		//rgb min
		if(r<g){
			if(r<b)rgb_min=r;
			else   rgb_min=b;
		}
		else{
			if(g<b)rgb_min=g;
			else   rgb_min=b;
		}

		if(r>95 && g>40 && b>20 && r>g && (rgb_max-rgb_min)>15 && r_g>15 && r>g && r>b ){			
			outPtr[i+0]=0;outPtr[i+1]=0;outPtr[i+2]=0;
			if(BPP == 4)
				outPtr[i+3]=0;
		}
		else
		{
			outPtr[i+0]=255;outPtr[i+1]=255;outPtr[i+2]=255;
			if(BPP == 4)
				outPtr[i+3]=255;
		}		
	}	
}



/////////////////////////////////////////////////////////////////////////////
//ħ		////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//ħ 꿡 Ʈ  Ǿ ϴ
void m_MorphologyBinaryErosion(ARUint8   *dataPtr,ARUint8   *outPtr,int xsize, int ysize)
{

	int flagPassed;
	int y,x,i;
	int mx,my;
	pStructureElementBinary m_pSEBinary=new StructureElementBinary[9];

	//ȭ  ʱȭ
	m_pSEBinary[0].y=-1;m_pSEBinary[0].x=-1;m_pSEBinary[1].y=-1;
	m_pSEBinary[1].x=0;	m_pSEBinary[2].y=-1;m_pSEBinary[2].x=1;		

	m_pSEBinary[3].y=0;	m_pSEBinary[3].x=-1;m_pSEBinary[4].y=0;
	m_pSEBinary[4].x=0;	m_pSEBinary[5].y=0;	m_pSEBinary[5].x=1;	

	m_pSEBinary[6].y=1;	m_pSEBinary[6].x=-1;m_pSEBinary[7].y=1;
	m_pSEBinary[7].x=0;	m_pSEBinary[8].y=1;	m_pSEBinary[8].x=1;	

	// ̹ BACKGROUND=255  ʱȭ 
	for(y=0;y<ysize;y++){
		for(x=0;x<xsize;x++){
			outPtr[y*xsize*BPP+x*BPP]=BACKGROUND;
			outPtr[y*xsize*BPP+x*BPP+1]=BACKGROUND;
			outPtr[y*xsize*BPP+x*BPP+2]=BACKGROUND;
			outPtr[y*xsize*BPP+x*BPP+3]=BACKGROUND;
		}
	}

	for(y=0;y<ysize;y++){
		for(x=0;x<xsize;x++){
			flagPassed=1;

			for(i=0;i<9;i++){
				mx=x+m_pSEBinary[i].x;
				my=y+m_pSEBinary[i].y;
				// ˻
				if(mx>=0 && mx<xsize && my>=0 && my<ysize){
					//ϳ BACKGROUND=255 ϸ ħĵȴ.
					if(dataPtr[my*xsize*BPP+mx*BPP]==BACKGROUND){
						flagPassed=0;
						break;
					}
				}
			}
			// κ, ħĵ  κ 
			if(flagPassed){
				outPtr[y*xsize*BPP+x*BPP  ]=FOREGROUND;
				outPtr[y*xsize*BPP+x*BPP+1]=FOREGROUND;
				outPtr[y*xsize*BPP+x*BPP+2]=FOREGROUND;
				if(BPP == 4)
					outPtr[y*xsize*BPP+x*BPP+3]=FOREGROUND;
			}
		}
	}	

	delete m_pSEBinary;
}

/////////////////////////////////////////////////////////////////////////////
//â		////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//ħ 꿡 Ʈ  Ǿ ϴ
void m_MorphologyBinaryDilation(ARUint8   *dataPtr,ARUint8   *outPtr,int xsize, int ysize)
{

	int flagPassed;
	int y,x,i;
	int mx,my;
	pStructureElementBinary m_pSEBinary=new StructureElementBinary[9];

	//ȭ  ʱȭ	

	m_pSEBinary[0].y=-1;m_pSEBinary[0].x=-1;m_pSEBinary[1].y=-1;
	m_pSEBinary[1].x=0;	m_pSEBinary[2].y=-1;m_pSEBinary[2].x=1;		

	m_pSEBinary[3].y=0;	m_pSEBinary[3].x=-1;m_pSEBinary[4].y=0;
	m_pSEBinary[4].x=0;	m_pSEBinary[5].y=0;	m_pSEBinary[5].x=1;	

	m_pSEBinary[6].y=1;	m_pSEBinary[6].x=-1;m_pSEBinary[7].y=1;
	m_pSEBinary[7].x=0;	m_pSEBinary[8].y=1;	m_pSEBinary[8].x=1;	



	// ̹ BACKGROUND=255  ʱȭ
	for(y=0;y<ysize;y++){
		for(x=0;x<xsize;x++){
			outPtr[y*xsize*BPP+x*BPP]=BACKGROUND;
			outPtr[y*xsize*BPP+x*BPP+1]=BACKGROUND;
			outPtr[y*xsize*BPP+x*BPP+2]=BACKGROUND;
			if(BPP == 4)
				outPtr[y*xsize*BPP+x*BPP+3]=BACKGROUND;
		}
	}

	for(y=0;y<ysize;y++){
		for(x=0;x<xsize;x++){
			flagPassed=0;

			for(i=0;i<9;i++){
				mx=x+m_pSEBinary[i].x;
				my=y+m_pSEBinary[i].y;
				// ˻
				if(mx>=0 && mx<xsize && my>=0 && my<ysize){
					//ϳ BACKGROUND=0 ϸ   for loop .
					//ħİ Ʒ  ٸ Ʋ
					if(dataPtr[my*xsize*BPP+mx*BPP]==FOREGROUND){
						flagPassed=1;
						break;
					}
				}
			}
			// κ, ħĵ  κ 
			if(flagPassed){
				outPtr[y*xsize*BPP+x*BPP  ]=FOREGROUND;
				outPtr[y*xsize*BPP+x*BPP+1]=FOREGROUND;
				outPtr[y*xsize*BPP+x*BPP+2]=FOREGROUND;
				if(BPP == 4)
					outPtr[y*xsize*BPP+x*BPP+3]=FOREGROUND;
			}			
		}
	}

	delete m_pSEBinary;
}




void resize_image(ARUint8   *dataPtr,ARUint8   *outPtr,int xsize,int ysize,float x_scale,float y_scale)
{		
	int new_rows=ysize*y_scale;//480
	int new_cols=xsize*x_scale;//640
	int y,x;
	
	unsigned long X_Source,Y_Source;
	unsigned long index;	
	unsigned long source_index;	

	
	for(y=0;y<new_rows;y++){		
		for(x=0;x<new_cols;x++){			
			index=y*new_cols*BPP+x*BPP;
			X_Source = (unsigned long)((x/x_scale)+0.5);
			if(X_Source>=xsize)
				X_Source=xsize-1;
			Y_Source = (unsigned long)((y/y_scale)+0.5);
			if(Y_Source>=ysize)
				Y_Source=ysize-1;

			source_index = Y_Source * xsize*BPP + X_Source*BPP;			

			outPtr[index+0]=dataPtr[source_index+0];
			outPtr[index+1]=dataPtr[source_index+1];
			outPtr[index+2]=dataPtr[source_index+2];
		}
	}		

}


///////////////////////////////////////////////////////////////////////////////////////////////
//init
///////////////////////////////////////////////////////////////////////////////////////////////
void init_image(ARUint8   *dataPtr,int xsize,int ysize,int data)
{
	unsigned long index;

	int x,y;

	for(y=0;y<ysize;y++)
	{
		index=y*xsize*BPP;
		for(x=0;x<xsize;x=x+1)
		{			
			dataPtr[index+x*BPP+0]=data;
			dataPtr[index+x*BPP+1]=data;
			dataPtr[index+x*BPP+2]=data;
			if(BPP == 4)
				dataPtr[index+x*BPP+3]=data;
		}
	}
}

void init_binary(ARUint8   *dataPtr,ARUint8 outPtr[],int xsize,int ysize,int data)
{
	unsigned long index;

	int x,y;
	int avg;

	for(y=0;y<ysize;y++)
	{
		index=y*xsize*BPP;
		for(x=0;x<xsize;x=x+1)
		{	
			avg=(int)(dataPtr[index+x*BPP+0]+dataPtr[index+x*BPP+1]+dataPtr[index+x*BPP+2])/3;
			if(avg>data)
			{
				outPtr[index+x*BPP+0]=255;
				outPtr[index+x*BPP+1]=255;
				outPtr[index+x*BPP+2]=255;
				if(BPP == 4)
					outPtr[index+x*BPP+3]=255;
			}
			else
			{
				outPtr[index+x*BPP+0]=0;
				outPtr[index+x*BPP+1]=0;
				outPtr[index+x*BPP+2]=0;
				if(BPP == 4)
					outPtr[index+x*BPP+3]=0;
			}
		}
	}
}

void convert_gray(ARUint8   *dataPtr,ARUint8 outPtr[],int xsize,int ysize)
{
	unsigned long index;

	int x,y;
	int avg;

	for(y=0;y<ysize;y++)
	{
		index=y*xsize*BPP;
		for(x=0;x<xsize;x=x+1)
		{			
			avg=(int)(dataPtr[index+x*BPP+0]+dataPtr[index+x*BPP+1]+dataPtr[index+x*BPP+2])/3;
			outPtr[index+x*BPP+0]=avg;
			outPtr[index+x*BPP+1]=avg;
			outPtr[index+x*BPP+2]=avg;

		}
	}	
}
void image_copy(ARUint8   *dataPtr,ARUint8 outPtr[],int xsize,int ysize)
{
	unsigned long index;
	int x,y;
	for(y=0;y<ysize;y++)
	{
		index=y*xsize*BPP;
		for(x=0;x<xsize;x=x+1)
		{			
			dataPtr[index+x*BPP+0]=outPtr[index+x*BPP+0];
			dataPtr[index+x*BPP+1]=outPtr[index+x*BPP+1];
			dataPtr[index+x*BPP+2]=outPtr[index+x*BPP+2];
			if(BPP == 4)
				dataPtr[index+x*BPP+3]=outPtr[index+x*BPP+3];
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////
//                              Ƽؽ
//////////////////////////////////////////////////////////////////////////////////////////////
#define MAX_RETINEX_SCALES    8
#define RETINEX_UNIFORM 0
#define RETINEX_LOW     1
#define RETINEX_HIGH    2


typedef struct
{
	int    N;
	float  sigma;
	double B;
	double b[4];
} gauss3_coefs;

typedef struct
{
	int     scale;
	int     nscales;
	int     scales_mode;
	float   cvar;
} RetinexParams;

static RetinexParams rvals =
{
	240,             /* Scale */
	3,               /* Scales */
	RETINEX_HIGH, //RETINEX_LOW, //RETINEX_UNIFORM, /* Echelles reparties uniformement */
	1.2              /* A voir */
};

static float RetinexScales[MAX_RETINEX_SCALES];


static void     retinex_scales_distribution (float       *scales,
											 int          nscales,
											 int          mode,
											 int          s);

static void     compute_coefs3              (gauss3_coefs *c,
											 float        sigma);
static void     gausssmooth                 (double       *in,
											 double       *out,
											 int          size,
											 int          rowtride,
											 gauss3_coefs *c);
static void     compute_mean_var            (double       *src,
											 double       *mean,
											 double       *var,
											 int          size,
											 int          bytes);


void MSRCR(ARUint8 *src,int width,int height,int bytes)
{
	int           scale;
	double        weight;
	gauss3_coefs  coef;
	double        mean, var;
	double        mini, range, maxi;
	double        alpha;
	double        gain;
	double        offset;
	double        max_preview = 0.0;
	int i;
	int pos;


	/* Allocate all the memory needed for algorithm*/
	int size = width * height * bytes;
	double *dst = (double*) malloc (size * sizeof (double));
	memset(dst, 0, sizeof(double) * size) ;

	int channelsize  = (width * height);
	double* in  = (double *) malloc (channelsize * sizeof (double));
	memset(in, 0, sizeof(double) * channelsize) ;

	double *out  = (double *) malloc (channelsize * sizeof (double));
	memset(out, 0, sizeof(double) * channelsize) ;

	/*
	Calculate the scales of filtering according to the
	number of filter and their distribution.
	*/

	retinex_scales_distribution (RetinexScales,
		rvals.nscales, rvals.scales_mode, rvals.scale);

	/*
	Filtering according to the various scales.
	Summerize the results of the various filters according to a
	specific weight(here equivalent for all).
	*/
	weight = 1./ (double) rvals.nscales;

	/*
	The recursive filtering algorithm needs different coefficients according
	to the selected scale (~ = standard deviation of Gaussian).
	*/


	for (int channel = 0; channel < 3; channel++) {
		for (i = 0, pos = channel; i < channelsize ; i++, pos += bytes) {
			/* 0-255 => 1-256 */
			in[i] = (double)(src[pos] + 1.0);
		}
		for (scale = 0; scale < rvals.nscales; scale++) {
			compute_coefs3 (&coef, RetinexScales[scale]);
			/*
			*  Filtering (smoothing) Gaussian recursive.
			*  Filter rows first
			*/
			for (int row=0 ;row < height; row++) {
				pos =  row * width;
				gausssmooth (in + pos, out + pos, width, 1, &coef);
			}

			memcpy(in,  out, channelsize * sizeof(double));
			memset(out, 0  , channelsize * sizeof(double));

			/*
			*  Filtering (smoothing) Gaussian recursive.
			*  Second columns
			*/
			for (int col=0; col < width; col++) {
				pos = col;
				gausssmooth(in + pos, out + pos, height, width, &coef);
			}

			/*
			Summarize the filtered values.
			In fact one calculates a ratio between the original values and the filtered values.
			*/
			for (i = 0, pos = channel; i < channelsize; i++, pos += bytes) {
				dst[pos] += weight * (log (src[pos] + 1.) - log (out[i]));
			}
		}
	}
	free(in);
	free(out);

	/*
	Final calculation with original value and cumulated filter values.
	The parameters gain, alpha and offset are constants.
	*/
	/* Ci(x,y)=log[a Ii(x,y)]-log[ Ei=1-s Ii(x,y)] */

	alpha  = 128.;
	gain   = 1.;
	offset = 0.;

	for (int i = 0; i < size; i += bytes) {
		double logl;
		ARUint8 *psrc = src+i;
		double *pdst = dst+i;
		logl = log((double)psrc[0] + (double)psrc[1] + (double)psrc[2] + 3.);
		pdst[0] = gain * ((log(alpha * (psrc[0]+1.)) - logl) * pdst[0]) + offset;
		pdst[1] = gain * ((log(alpha * (psrc[1]+1.)) - logl) * pdst[1]) + offset;
		pdst[2] = gain * ((log(alpha * (psrc[2]+1.)) - logl) * pdst[2]) + offset;
	}

	/*
	** Adapt the dynamics of the colors according to the statistics of the first and second order.
	** The use of the variance makes it possible to control the degree of saturation of the colors.
	*/
	compute_mean_var (dst, &mean, &var, size, bytes);
	mini = mean - rvals.cvar*var;
	maxi = mean + rvals.cvar*var;
	range = maxi - mini;

	if (!range)
		range = 1.0;

	for (i = 0; i < size; i+= bytes) {
		ARUint8 *psrc = src + i;
		double *pdst = dst + i;
		for (int j = 0 ; j < 3 ; j++) {
			double c = 255.0 * ( pdst[j] - mini ) / range;
			int ic = (int)c  ;
			psrc[j] = ic<0? 0 : ic>255 ? 255 : ic;
		}
	}

	free (dst);
};

static void
compute_mean_var (double *src, double *mean, double *var, int size, int bytes) {
	double s =0;
	double ss=0;
	for(int i=0; i<size; i += bytes){
		double *psrc = src + i ;
		for(int j=0; j<3; j++){
			int a = psrc[j];
			s += a ;
			ss += a * a ;
		}
	}
	*var = ( ss - (s * s) /size ) /size;
	*mean = s / size;
	*var = sqrt(*var); //std-deviation;
}


static void
gausssmooth (double *in, double *out, int size, int rowstride, gauss3_coefs *c)
{
	/*
	* Papers:  "Recursive Implementation of the gaussian filter.",
	*          Ian T. Young , Lucas J. Van Vliet, Signal Processing 44, Elsevier 1995.
	* formula: 9a        forward filter
	*          9b        backward filter
	*          fig7      algorithm
	*/
	int i,n, bufsize;
	double *w1,*w2;

	/* forward pass */
	bufsize = size+3;
	size -= 1;
	w1 = (double *) malloc (bufsize * sizeof (double));
	w2 = (double *) malloc (bufsize * sizeof (double));
	w1[0] = in[0];
	w1[1] = in[0];
	w1[2] = in[0];
	for ( i = 0 , n=3; i <= size ; i++, n++)
	{
		w1[n] = (double)(c->B*in[i*rowstride] +
			((c->b[1]*w1[n-1] +
			c->b[2]*w1[n-2] +
			c->b[3]*w1[n-3] ) / c->b[0]));
	}

	/* backward pass */
	w2[size+1]= w1[size+3];
	w2[size+2]= w1[size+3];
	w2[size+3]= w1[size+3];
	for (i = size, n = i; i >= 0; i--, n--)
	{
		w2[n]= out[i * rowstride] = (double)(c->B*w1[n] +
			((c->b[1]*w2[n+1] +
			c->b[2]*w2[n+2] +
			c->b[3]*w2[n+3] ) / c->b[0]));
	}

	free (w1);
	free (w2);
}

static void compute_coefs3 (gauss3_coefs *c, float sigma)
{
	/*
	* Papers:  "Recursive Implementation of the gaussian filter.",
	*          Ian T. Young , Lucas J. Van Vliet, Signal Processing 44, Elsevier 1995.
	* formula: 11b       computation of q
	*          8c        computation of b0..b1
	*          10        alpha is normalization constant B
	*/
	float q, q2, q3;

	q = 0;

	if (sigma >= 2.5)
	{
		q = 0.98711 * sigma - 0.96330;
	}
	else if ((sigma >= 0.5) && (sigma < 2.5))
	{
		q = 3.97156 - 4.14554 * (float) sqrt ((double) 1 - 0.26891 * sigma);
	}
	else
	{
		q = 0.1147705018520355224609375;
	}

	q2 = q * q;
	q3 = q * q2;
	c->b[0] = (1.57825+(2.44413*q)+(1.4281 *q2)+(0.422205*q3));
	c->b[1] = (        (2.44413*q)+(2.85619*q2)+(1.26661 *q3));
	c->b[2] = (                   -((1.4281*q2)+(1.26661 *q3)));
	c->b[3] = (                                 (0.422205*q3));
	c->B = 1.0-((c->b[1]+c->b[2]+c->b[3])/c->b[0]);
	c->sigma = sigma;
	c->N = 3;
}

static void retinex_scales_distribution(float* scales, int nscales, int mode, int s)
{
	if (nscales == 1)
	{ /* For one filter we choose the median scale */
		scales[0] = (int) s / 2;
	}
	else if (nscales == 2)
	{ /* For two filters whe choose the median and maximum scale */
		scales[0] = (int) s / 2;
		scales[1] = (int) s;
	}
	else
	{
		float size_step = (float) s / (float) nscales;
		int   i;

		switch(mode)
		{
		case RETINEX_UNIFORM:
			for(i = 0; i < nscales; ++i)
				scales[i] = 2. + (float) i * size_step;
			break;

		case RETINEX_LOW:
			size_step = (float) log(s - 2.0) / (float) nscales;
			for (i = 0; i < nscales; ++i)
				scales[i] = 2. + pow (10, (i * size_step) / log (10.));
			break;

		case RETINEX_HIGH:
			size_step = (float) log(s - 2.0) / (float) nscales;
			for (i = 0; i < nscales; ++i)
				scales[i] = s - pow (10, (i * size_step) / log (10.));
			break;

		default:
			break;
		}
	}
}




///////////////////////////////////////
// ȭ
///////////////////////////////////////

typedef struct{
	int col;
	int row;
}StructElementBin;

void m_Thinning(ARUint8   *dataPtr,ARUint8 outPtr[],int xsize,int ysize){

	//c1,c2,c3,c4 ˻Һ
	int i, j, c1=0, c2=0, c3=0, c4=0, tot;
	int x,y;
	int np1=0, sp1=0;
	int cnt=0, chk=0, flag=0;	
	int *pThinImg;
	int ysize1=ysize-1, xsize1=xsize-1;
	//̹µ޸Ҵ
	pThinImg = new int[ysize*xsize];

	ARUint8	data[240][320];	
	for(y=0;y<ysize;y++){
		for(x=0;x<xsize;x++){
			data[y][x]=dataPtr[y*xsize*BPP+x*BPP];			
		}
	}

	static int count=0;


	//ȭݺ
	do {
		// θȼʱȭ
		for (y=0;y<ysize;y++)
			for( x=0;x<xsize;x++)  
				pThinImg[y*xsize+x]=255;

		//ؾȼ̴̻flag=0
		flag=0;
		chk=cnt%2; //ܰ, ܰ踦
		cnt++;	   	
		//1,2,3,4˻Ͽϳ󵵸ġȼ255
		for (y=1;y<ysize1;y++){
			for(x=1;x<xsize1;x++){
				if (data[y][x]==0)
				{	
					c1=0;c2=0;c3=0;c4=0;sp1=0;

					np1= data[y-1][x-1]+data[y-1][x]+data[y-1][x+1]
					+data[y][x-1]                  +data[y][x+1]
					+data[y+1][x-1]+data[y+1][x]+data[y+1][x+1];


					//ǰ˻: ϸ0 => ȼ
					if(np1>=2*255 && np1<=6*255) c1=0;
					else c1=1;
					
					//ǰ˻
					if(data[y-1][x]==0 && data[y-1][x+1]==255) sp1++;
					if(data[y-1][x+1]==0 && data[y][x+1]==255) sp1++;
					if(data[y][x+1]==0 && data[y+1][x+1]==255) sp1++;
					if(data[y+1][x+1]==0 && data[y+1][x]==255) sp1++;
					if(data[y+1][x]==0 && data[y+1][x-1]==255) sp1++;
					if(data[y+1][x-1]==0 && data[y][x-1]==255) sp1++;
					if(data[y][x-1]==0 && data[y-1][x-1]==255) sp1++;
					if(data[y-1][x-1]==0 && data[y-1][x]==255) sp1++;
					//ǰǸc2=0 => ȼ
					if(sp1==1) c2=0;
					else c2=1;
					//, ǰ˻ϴµȦ°´ܰ¦°´ܰ踦
					if(chk==0){
						c3=data[y-1][x]*data[y][x+1]*data[y+1][x];
						c4=data[y][x+1]*data[y+1][x]*data[y][x-1];
					}else{
						c3=data[y-1][x]*data[y][x+1]*data[y][x-1];
						c4=data[y-1][x]*data[y+1][x]*data[y][x-1];
					}

					tot=c1 || c2 || c3 || c4;
					if(tot) pThinImg[y*xsize+x]=0;//ϳ   ־ߵȴ.
					else flag=1;  //  ,  0̸ ״ · д.

				}			
			}	
		}

		//ȼϿѴܰĿupgrade
		
		for (y=1;y<ysize1;y++){
			for(x=1;x<xsize1;x++){
				data[y][x]=pThinImg[y*xsize+x];		  
			}
		}
		
	}while(flag);	

	for(y=0;y<ysize;y++){
		for(x=0;x<xsize;x++){
			outPtr[y*xsize*BPP+x*BPP]  =data[y][x];						
			outPtr[y*xsize*BPP+x*BPP+1]=data[y][x];			
			outPtr[y*xsize*BPP+x*BPP+2]=data[y][x];			
		}
	}

	delete [] pThinImg;
}
