#include <stdio.h>
#include <stdlib.h>
#include "SDL.h"
#include "SDL_mixer.h"


#define NUM_SOUND 21
static int audio_opened =0;
static Mix_Chunk *wave[NUM_SOUND] ={NULL};

static int input=0;

// loagalbe elemental//
char *elem[NUM_SOUND]={
	"./Data/wav/a.wav",
	"./Data/wav/b.wav",
	"./Data/wav/c.wav",
	"./Data/wav/d.wav",
	"./Data/wav/e.wav",
	"./Data/wav/f.wav",
	"./Data/wav/g.wav",
	"./Data/wav/h.wav",
	"./Data/wav/choco.wav",//ʵ  /    8 /   7
	"./Data/wav/click.wav",
	
	"./Data/wav/sphere_mode.wav",//mix (10)
	"./Data/wav/cone_mode.wav",  //mix (11)
	"./Data/wav/torus_mode.wav", //mix (12)
	"./Data/wav/erase_mode.wav", //mix (13)

	"./Data/wav/red_color.wav",  //mix (14)
	"./Data/wav/green_color.wav",//mix (15)
	"./Data/wav/blue_color.wav", //mix (16)
	"./Data/wav/black_color.wav",//mix (17)

	"./Data/wav/piano_mode.wav", //mix (18)
	"./Data/wav/garfield_mode.wav",//mix (19)
 
	"./Data/wav/left_click.wav"//mix (20)



};

/*
//eable getch()
int kgetch(void)
{
	int ch;
	struct termios buf;
	struct termios save;


	tcgetattr(0, &save);
	buf = save;
	buf.c_lflag &= ~(ICANON|ECHO);
	buf.c_cc[VMIN] = 1;
	buf.c_cc[VTIME] = 0;
	tcsetattr(0, TCSAFLUSH, &buf);
	ch = getchar();
	tcsetattr(0, TCSAFLUSH, &save);
	return ch;
}
*/


//audio clean_up func
void mix_clean_up(void)
{	
	int num;	
	for (num=0;num<NUM_SOUND;num++)
	{
		if(wave[num]==NULL){
			Mix_FreeChunk(wave[num]);				
			wave[num]=NULL;
		}
	}	
	if(audio_opened)
	{
		Mix_CloseAudio();
		audio_opened=0;
	}
	free(elem);
	
	atexit(SDL_Quit);
}

void mix_init()
{
	int num;

	//audio initialize	
	if(SDL_Init(SDL_INIT_AUDIO)<0){
		fprintf(stderr,"SDL Initialize error :%s\n",SDL_GetError());
		return;
	}else{
		printf("SDL_init OK\n");
	}

	

	// audio open and setting
	//22050 2 ־µ,  ̴ Ҹ ϱ
	if(Mix_OpenAudio( 22050, MIX_DEFAULT_FORMAT, 2,1024 )/*Mix_OpenAudio(MIX_DEFAULT_FREQUENCY,MIX_DEFAULT_FORMAT,2,4096)*/<0){
		fprintf(stderr,"can't open audio device :%s\n",SDL_GetError());
		return;
	}else{
		printf("Mix_OpenAudio OK\n");
	}

	//load elemental
	for(num=0;num<NUM_SOUND;num++)
	{
		wave[num]=Mix_LoadWAV(elem[num]);

		if(wave[num]==NULL){
			fprintf(stderr,"wave load fail :%s\n",SDL_GetError());
			printf("wave[num]=%d\n",num);
			return;
		}
	}
}

void mix_off(int input){
	Mix_HaltChannel(input);
}

void mix(int input)
{		
	//play sound
	static int s_channel=-1;

	//ʵ 
	if(input==8){	
		//÷  ʰ ִٸ ÷ض
		//7 ִ ε
		if(Mix_Playing(s_channel) == 0)
			s_channel=Mix_PlayChannel(7,wave[input],0);
	}
	else
		Mix_PlayChannel(-1,wave[input],0);
}



